#ifndef __FORMAT_H
#define __FORMAT_H

#define LOAD_OUTPUT_FORMAT "ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u l %c addr:%20p %u\n", \
                       ip,     ebp,     sp,     (void*)xor_sign,      thread_id, valid, addr,     sincelast
#define STORE_OUTPUT_FORMAT "ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u s %c addr:%20p %u\n", \
                       ip,     ebp,     sp,     (void*)xor_sign,      thread_id, valid, addr,     sincelast
#define INPUT_FORMAT   "ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u %c %c addr:%20p %u\n", \
                       &ip,     &ebp,     &sp,     &sign,      &thread_id, &type, &valid, &addr,     &sincelast

#endif
