#include <stdio.h>
#include "myqueue.cpp"
#include "sigt.cpp"

#define PRSD_PIPE "./log.txt"  //"/home/sbudanu/prsd_pipe"

LIST<void*> signList;
FILE* fpipe = NULL;
SIGTREE *sigTree = NULL;
		
void addToSigTree(LIST<void*> *l)
{
	SIGNODE* leaf = NULL;
	#if 0
	void* val = NULL;
	LIST_RITERATOR<void*> *iter = NULL;
	iter = l->createRIterator();
	
	//indicate the tree object that adding pc/ra is going to start
	sigTree->initAdding();	
	while(iter->next())
	{
		val = iter->currentItem();
		//fprintf(stdout, " %20p", (void*)val);
		leaf = (SIGNODE*)sigTree->add(val);
		printf("\n**%p**", leaf->info);
	}
	sigTree->finishAdding();
	l->releaseRIterator(iter);
	#else
	leaf = (SIGNODE*)sigTree->add(l);
	printf("\n**%p**", leaf->info);	
	#endif
	return;
}	

int main()
{
	long val = NULL;
	long list_size;
	int num = 0;
	char lt, gt;
	void *ip = NULL, *addr = NULL, *sp = NULL, *ebp = NULL, *sign = NULL;
	unsigned int thread_id = 0, sincelast = 0;
	char valid, type;
	
  	if((fpipe = fopen(PRSD_PIPE, "r"))== NULL)
  	{
	   printf("pipe %s not present....:!exiting\n", PRSD_PIPE);
	   return -1;
	}

	sigTree = new SIGTREE();
   
	while(1)
	{
		num = fscanf(fpipe,"\n*%ld*", &list_size);
   		if(num == 0 || num == -1){printf("\nEOF reached or ERROR#1....%d\n",num);break;}
		num = fscanf(fpipe,"\n%c", &lt);		
   		if(num == 0 || num == -1){printf("\nEOF reached or ERROR#2....%d\n",num);break;}
		while(list_size--)
		{
			fscanf(fpipe, " %20p", &val);	
   			if(num == 0 || num == -1){printf("\nEOF reached or ERROR#3....%d\n",num);break;}
	  		signList.addTail((void*)val);
			//fprintf(stdout, "% 20p", (void*)val);			
		}
		addToSigTree(&signList);
		signList.removeAll();
		 
		//fprintf(stdout, "\n");
		fscanf(fpipe, "%c\n", &gt);
   		if(num == 0 || num == -1){printf("\nEOF reached or ERROR#4....%d\n",num);break;}
		
		num = fscanf(fpipe,"ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u %c %c addr:%20p %u\n",
                     &ip,     &ebp,     &sp,     &sign,      &thread_id, &type, &valid, &addr, &sincelast);
   		if(num == 0 || num == -1){printf("\nEOF reached or ERROR#5....%d\n",num);break;}
	}
		sigTree->print();
		cout<<"\n"<<"New: "<<sigTree->getChildNodeCount()<<" Dups: "<<sigTree->getDuplicateCount()<<"\n";
		sigTree->~SIGTREE();
		return 0;
}
